﻿using System;
using System.Collections.Generic;
using UnityEngine;

public abstract class ATwistCtrl
{
	public ATwistCtrl(Maid.AutoTwist twist_type, TBody body)
	{
		this.twistType = twist_type;
		this.twistBones = new List<KeyValuePair<Transform, Transform>>();
		this.body = body;
	}

	public Transform bone { get; protected set; }

	public Transform mrBone { get; protected set; }

	public List<KeyValuePair<Transform, Transform>> twistBones { get; protected set; }

	public abstract void ApplyTwist();

	protected Transform GetMRBone(string bone_name)
	{
		return this.body.m_dicBonesMR[bone_name];
	}

	public readonly Maid.AutoTwist twistType;

	public readonly TBody body;
}
