﻿using System;
using UnityEngine;

public class BodySelectMgr : BaseMgr<BodySelectMgr>
{
	private void Start()
	{
		UIRoot componentInParent = base.GetComponentInParent<UIRoot>();
		this.m_goBodySelectPanel = componentInParent.transform.Find("BodySelectPanel").gameObject;
		if (this.m_goBodySelectPanel == null)
		{
			Debug.LogError(string.Format("{0}が見つかりませんでした", "BodySelectPanel"));
			return;
		}
		this.m_goBodySelectPanel.SetActive(false);
		this.m_bodySelectCtrl = this.m_goBodySelectPanel.GetComponent<BodySelectCtrl>();
		this.m_sceneEdit = GameObject.Find("__SceneEdit__").GetComponent<SceneEdit>();
	}

	public void OpenBodySelectPanel()
	{
		this.m_goBodySelectPanel.SetActive(true);
		this.m_bodySelectCtrl.NewBodyButtonEnabled(this.m_sceneEdit.maid.HasCrcBody);
	}

	public void CloseBodySelectPanel()
	{
		this.m_goBodySelectPanel.SetActive(false);
	}

	private void Update()
	{
	}

	private GameObject m_goBodySelectPanel;

	private BodySelectCtrl m_bodySelectCtrl;

	private SceneEdit m_sceneEdit;
}
