﻿using System;
using wf.Serialization;

namespace CRCEdit
{
	[Serializable]
	public class ConfigBridgeData : AJsonSerializationVersionControl
	{
		public override int FixVersion
		{
			get
			{
				return 1000;
			}
		}

		public ConfigBridgeData.System system = new ConfigBridgeData.System();

		public ConfigBridgeData.Game game = new ConfigBridgeData.Game();

		public ConfigBridgeData.Sound sound = new ConfigBridgeData.Sound();

		[Serializable]
		public class System : AJsonSerializationVersionControl
		{
			public override int FixVersion
			{
				get
				{
					return 1000;
				}
			}

			public int windowSizeX;

			public int windowSizeY;

			public bool isFullScreenMode;

			public bool isVSyncEnabled;

			public int targetFrameRate;

			public int screenShotSuperSize;

			public int antiAlias;

			public int shadowQuality;

			public int textureQualit;

			public string videoPlayerPreferredFilter;

			public bool inputUseLegacyAxisMode;
		}

		[Serializable]
		public class Game : AJsonSerializationVersionControl
		{
			public override int FixVersion
			{
				get
				{
					return 1000;
				}
			}
		}

		[Serializable]
		public class Sound : AJsonSerializationVersionControl
		{
			public override int FixVersion
			{
				get
				{
					return 1000;
				}
			}

			public ConfigBridgeData.Sound.SimpleActorWrapper master = new ConfigBridgeData.Sound.SimpleActorWrapper();

			public ConfigBridgeData.Sound.SimpleActorWrapper system = new ConfigBridgeData.Sound.SimpleActorWrapper();

			public ConfigBridgeData.Sound.SimpleActorWrapper bgm = new ConfigBridgeData.Sound.SimpleActorWrapper();

			public ConfigBridgeData.Sound.SimpleActorWrapper dance = new ConfigBridgeData.Sound.SimpleActorWrapper();

			public ConfigBridgeData.Sound.ActorWrapper se = new ConfigBridgeData.Sound.ActorWrapper();

			public ConfigBridgeData.Sound.ActorWrapper voice = new ConfigBridgeData.Sound.ActorWrapper();

			public ConfigBridgeData.Sound.SimpleActorWrapper voiceHeroine = new ConfigBridgeData.Sound.SimpleActorWrapper();

			public bool isEjaculationSeEnabled;

			[Serializable]
			public class SimpleActorWrapper : AJsonSerializationVersionControl
			{
				public override int FixVersion
				{
					get
					{
						return 1000;
					}
				}

				public float voluem;

				public bool mute;
			}

			[Serializable]
			public class ActorWrapper : ConfigBridgeData.Sound.SimpleActorWrapper
			{
				public override int FixVersion
				{
					get
					{
						return 1000;
					}
				}

				public bool isPlay3DPositioning;
			}
		}
	}
}
