﻿using System;
using System.Collections;
using System.Collections.Generic;
using I2.Loc;
using MaidStatus;
using UnityEngine;
using wf;
using Yotogis;

public class FreeSkillSelect : MonoBehaviour
{
	public void Awake()
	{
		if (this.update_obj_dic_ != null)
		{
			return;
		}
		this.update_obj_dic_ = new Dictionary<string, FreeSkillSelect.UpdateObject>();
		Func<GameObject, FreeSkillSelect.UpdateObject> func = delegate(GameObject top_obj)
		{
			GameObject childObject = UTY.GetChildObject(top_obj, "Content", false);
			FreeSkillSelect.UpdateObject updateObject = new FreeSkillSelect.UpdateObject();
			updateObject.storage_obj = UTY.GetChildObject(childObject, "StorageRoom", true);
			updateObject.arrow_obj = UTY.GetChildObject(top_obj, "Arrow", false);
			updateObject.ui_panel = childObject.GetComponent<UIPanel>();
			updateObject.scroll_view = childObject.GetComponent<UIScrollView>();
			updateObject.button_parent = UTY.GetChildObject(childObject, "GridParent", false);
			updateObject.ui_grid = updateObject.button_parent.GetComponent<UIGrid>();
			updateObject.tab_panel = updateObject.button_parent.GetComponent<UIWFTabPanel>();
			return updateObject;
		};
		string[] array = new string[]
		{
			"TypeCategoryViewer",
			"CategoryViewer",
			"SkillSelectViewer",
			"LevelViewer",
			"StageSelectViewer"
		};
		string[] array2 = new string[]
		{
			"タイプ",
			"カテゴリー",
			"スキル",
			"レベル",
			"ステージ"
		};
		for (int i = 0; i < array.Length; i++)
		{
			this.update_obj_dic_.Add(array2[i], func(UTY.GetChildObject(base.gameObject, array[i], false)));
		}
		this.select_stage_ = (this.user_request_stage = YotogiStage.GetAllDatas(true)[0]);
	}

	public void Start()
	{
	}

	public void SetMaid(Maid maid)
	{
		this.maid_ = maid;
	}

	public void SetYotogiManager(YotogiManager yotogi_mgr)
	{
		this.yotogi_mgr_ = yotogi_mgr;
	}

	public void CreateInstanceButton()
	{
		if (this.button_data_list_ != null)
		{
			return;
		}
		FreeSkillSelect.UpdateObject updateObject = this.update_obj_dic_["ステージ"];
		FreeSkillSelect.UpdateObject updateObject2 = this.update_obj_dic_["タイプ"];
		FreeSkillSelect.UpdateObject updateObject3 = this.update_obj_dic_["レベル"];
		foreach (KeyValuePair<string, FreeSkillSelect.UpdateObject> keyValuePair in this.update_obj_dic_)
		{
			FreeSkillSelect.UpdateObject value = keyValuePair.Value;
			value.Clear();
			value.Update();
		}
		int clubGrade = GameMain.Instance.CharacterMgr.status.clubGrade;
		HashSet<int> hashSet = new HashSet<int>();
		List<YotogiStage.Data> allDatas = YotogiStage.GetAllDatas(true);
		allDatas.Sort();
		foreach (YotogiStage.Data data in allDatas)
		{
			if (data.isYotogiPlayable(this.maid_, clubGrade, false))
			{
				string a = string.Empty;
				for (int i = 0; i < 2; i++)
				{
					if (!string.IsNullOrEmpty(data.prefabName[i]) && !(a == data.prefabName[i]))
					{
						GameObject gameObject = Utility.CreatePrefab(updateObject.button_parent, "SceneYotogi/StageSelect/Prefab/StageUnit", true);
						a = (gameObject.name = data.prefabName[0]);
						YotogiStageUnit component = gameObject.GetComponent<YotogiStageUnit>();
						component.SetStageData(data, true, i == 0);
						component.SetOnSelectEvent(new YotogiStageUnit.OnSelectEvent(this.OnClickStageEvent));
						component.is_change_bg = false;
						if (!hashSet.Contains(data.id))
						{
							hashSet.Add(data.id);
						}
					}
				}
			}
		}
		updateObject.Update();
		this.button_data_list_ = FreeSkillSelect.CreateButtonData(this.maid_, hashSet);
		GameObject button_parent = updateObject3.button_parent;
		for (int j = 0; j < 3; j++)
		{
			EventDelegate onclick_event = new EventDelegate(this, "OnClickLevelBtnEvent");
			UIWFTabButton uiwftabButton = this.CreateTypeAndCategoryButton(updateObject3, "Lv." + (j + 1).ToString(), null, true, onclick_event);
			uiwftabButton.name = (j + 1).ToString();
		}
		updateObject3.Update();
		List<Transform> childList = updateObject3.ui_grid.GetChildList();
		for (int k = 0; k < childList.Count; k++)
		{
			UIWFTabButton componentInChildren = childList[k].gameObject.GetComponentInChildren<UIWFTabButton>();
			if (!(componentInChildren == null) && componentInChildren.isEnabled)
			{
				updateObject3.tab_panel.Select(componentInChildren);
				break;
			}
		}
		GameObject button_parent2 = updateObject2.button_parent;
		for (int l = 0; l < this.button_data_list_.Count; l++)
		{
			FreeSkillSelect.ButtonData buttonData = this.button_data_list_[l];
			EventDelegate eventDelegate = new EventDelegate(this, "OnClickTypeBtnEvent");
			eventDelegate.parameters[0].value = buttonData;
			if (buttonData.children_list.Count != 0)
			{
				buttonData.tab_button_obj = this.CreateTypeAndCategoryButton(updateObject2, buttonData.name, buttonData.nameTerm, 0 < this.button_data_list_[l].children_list.Count, eventDelegate);
				bool flag = false;
				foreach (FreeSkillSelect.ButtonData buttonData2 in buttonData.children_list)
				{
					foreach (FreeSkillSelect.ButtonData buttonData3 in buttonData2.children_list)
					{
						Skill.Data skill_data = buttonData3.skill_data;
						if (1 < skill_data.user_player_num)
						{
							int num = 1;
							while (num < skill_data.user_player_num && !flag)
							{
								Maid maid = GameMain.Instance.CharacterMgr.GetMaid(num);
								if (maid != null)
								{
									bool flag2 = !PersonalEventBlocker.IsEnabledYotodiSkill(maid.status.personal, skill_data.id);
									if (!skill_data.recollectionHaremLockPersonalIds.Contains(maid.status.personal.id) && !flag2)
									{
										flag = true;
									}
								}
								num++;
							}
						}
						else
						{
							flag = true;
						}
						if (flag)
						{
							break;
						}
					}
				}
				buttonData.tab_button_obj.isEnabled = flag;
			}
		}
		updateObject2.Update();
		childList = updateObject2.ui_grid.GetChildList();
		for (int m = 0; m < childList.Count; m++)
		{
			UIWFTabButton componentInChildren2 = childList[m].gameObject.GetComponentInChildren<UIWFTabButton>();
			if (!(componentInChildren2 == null) && componentInChildren2.isEnabled)
			{
				updateObject2.tab_panel.Select(componentInChildren2);
				break;
			}
		}
	}

	public void SelectSkill(Skill.Data skill, YotogiStage.Data stage_data)
	{
		if (skill == null)
		{
			return;
		}
		FreeSkillSelect.ButtonData buttonData = null;
		FreeSkillSelect.ButtonData buttonData2 = null;
		FreeSkillSelect.ButtonData buttonData3 = null;
		bool flag = true;
		int num = 0;
		while (num < this.button_data_list_.Count && flag)
		{
			buttonData = this.button_data_list_[num];
			int num2 = 0;
			while (num2 < buttonData.children_list.Count && flag)
			{
				buttonData2 = buttonData.children_list[num2];
				int num3 = 0;
				while (num3 < buttonData2.children_list.Count && flag)
				{
					buttonData3 = buttonData2.children_list[num3];
					if (buttonData3.skill_data == skill)
					{
						flag = false;
					}
					num3++;
				}
				num2++;
			}
			num++;
		}
		if (flag)
		{
			return;
		}
		if (!buttonData.tab_button_obj.isSelected)
		{
			this.update_obj_dic_["タイプ"].tab_panel.Select(buttonData.tab_button_obj);
		}
		if (!buttonData2.tab_button_obj.isSelected)
		{
			this.update_obj_dic_["カテゴリー"].tab_panel.Select(buttonData2.tab_button_obj);
		}
		this.user_request_stage = stage_data;
		if (!buttonData3.tab_button_obj.isSelected)
		{
			this.update_obj_dic_["スキル"].tab_panel.Select(buttonData3.tab_button_obj);
		}
	}

	public void FixSkill()
	{
		if (this.yotogi_mgr_ == null || this.yotogi_mgr_.maid == null)
		{
			return;
		}
		YotogiStageSelectManager.SelectStage(this.select_stage, this.is_day_time_);
		KeyValuePair<Skill.Data, bool>[] playSkillArray = new KeyValuePair<Skill.Data, bool>[]
		{
			new KeyValuePair<Skill.Data, bool>(this.select_skill, false)
		};
		this.yotogi_mgr_.SetPlaySkillArray(playSkillArray);
	}

	private void CreateCategory(FreeSkillSelect.ButtonData type_button_data)
	{
		FreeSkillSelect.UpdateObject updateObject = this.update_obj_dic_["カテゴリー"];
		updateObject.MoveStorageRoom(true);
		updateObject.Clear();
		GameObject button_parent = updateObject.button_parent;
		bool lockNTRPlay = GameMain.Instance.CharacterMgr.status.lockNTRPlay;
		int i = 0;
		while (i < type_button_data.children_list.Count)
		{
			FreeSkillSelect.ButtonData buttonData = type_button_data.children_list[i];
			if (!lockNTRPlay)
			{
				goto IL_87;
			}
			Yotogi.Category category = (Yotogi.Category)Enum.Parse(typeof(Yotogi.Category), buttonData.name);
			if (category != Yotogi.Category.交換 && category != Yotogi.Category.乱交)
			{
				goto IL_87;
			}
			IL_EE:
			i++;
			continue;
			IL_87:
			bool flag = buttonData.children_list != null && 0 < buttonData.children_list.Count;
			EventDelegate eventDelegate = null;
			if (flag)
			{
				eventDelegate = new EventDelegate(this, "OnClickCategoryBtnEvent");
				eventDelegate.parameters[0].value = buttonData;
			}
			buttonData.tab_button_obj = this.CreateTypeAndCategoryButton(updateObject, buttonData.name, buttonData.nameTerm, flag, eventDelegate);
			goto IL_EE;
		}
		updateObject.Update();
		List<Transform> childList = updateObject.ui_grid.GetChildList();
		for (int j = 0; j < childList.Count; j++)
		{
			UIWFTabButton componentInChildren = childList[j].gameObject.GetComponentInChildren<UIWFTabButton>();
			if (!(componentInChildren == null) && componentInChildren.isEnabled)
			{
				updateObject.tab_panel.Select(componentInChildren);
				break;
			}
		}
	}

	private void CreateSkill(FreeSkillSelect.ButtonData skill_button_data)
	{
		FreeSkillSelect.UpdateObject updateObject = this.update_obj_dic_["スキル"];
		updateObject.MoveStorageRoom(true);
		updateObject.Clear();
		GameObject button_parent = updateObject.button_parent;
		for (int i = 0; i < skill_button_data.children_list.Count; i++)
		{
			FreeSkillSelect.ButtonData buttonData = skill_button_data.children_list[i];
			if (buttonData.skill_data != null)
			{
				EventDelegate eventDelegate = new EventDelegate(this, "OnClickSkillBtnEvent");
				eventDelegate.parameters[0].value = buttonData;
				buttonData.tab_button_obj = this.CreateSkillButton(buttonData.skill_data, eventDelegate);
			}
		}
		updateObject.Update();
		List<Transform> childList = updateObject.ui_grid.GetChildList();
		for (int j = 0; j < childList.Count; j++)
		{
			UIWFTabButton componentInChildren = childList[j].gameObject.GetComponentInChildren<UIWFTabButton>();
			if (!(componentInChildren == null) && componentInChildren.isEnabled)
			{
				updateObject.tab_panel.Select(componentInChildren);
				break;
			}
		}
	}

	private void CreateStage(Skill.Data skill_data)
	{
		FreeSkillSelect.UpdateObject updateObject = this.update_obj_dic_["ステージ"];
		YotogiStage.Data data = this.user_request_stage;
		UIWFTabButton uiwftabButton = null;
		updateObject.tab_panel.ResetSelect();
		List<Transform> childList = updateObject.ui_grid.GetChildList();
		for (int i = 0; i < childList.Count; i++)
		{
			YotogiStageUnit component = childList[i].gameObject.GetComponent<YotogiStageUnit>();
			UIWFTabButton componentInChildren = childList[i].gameObject.GetComponentInChildren<UIWFTabButton>();
			if (componentInChildren.isSelected)
			{
				componentInChildren.SetSelect(false);
			}
			if (componentInChildren.isEnabled != skill_data.IsExecStage(component.stage_data))
			{
				componentInChildren.isEnabled = skill_data.IsExecStage(component.stage_data);
				if (componentInChildren.isEnabled)
				{
					component.thumbnail_sprite.color = new Color(1f, 1f, 1f, 1f);
				}
				else
				{
					component.thumbnail_sprite.color = new Color(0.6f, 0.6f, 0.6f, 1f);
				}
			}
			if (data == component.stage_data && componentInChildren.isEnabled)
			{
				uiwftabButton = componentInChildren;
			}
		}
		if (uiwftabButton != null)
		{
			updateObject.tab_panel.Select(uiwftabButton);
		}
		else
		{
			for (int j = 0; j < childList.Count; j++)
			{
				UIWFTabButton componentInChildren2 = childList[j].gameObject.GetComponentInChildren<UIWFTabButton>();
				if (!(componentInChildren2 == null) && componentInChildren2.isEnabled)
				{
					updateObject.tab_panel.Select(componentInChildren2);
					break;
				}
			}
			this.user_request_stage = data;
		}
	}

	private UIWFTabButton CreateSkillButton(Skill.Data skill_data, EventDelegate onclick_event)
	{
		if (skill_data == null)
		{
			return null;
		}
		FreeSkillSelect.UpdateObject updateObject = this.update_obj_dic_["スキル"];
		GameObject gameObject = updateObject.MoveButtonParent();
		if (gameObject == null)
		{
			gameObject = Utility.CreatePrefab(updateObject.button_parent, "SceneYotogi/FreeMode/FreeSkillButton", true);
		}
		UILabel component = UTY.GetChildObject(gameObject, "title", false).GetComponent<UILabel>();
		Localize component2 = component.GetComponent<Localize>();
		component.text = skill_data.name;
		gameObject.name = skill_data.name;
		if (component2 != null)
		{
			component2.SetTerm(skill_data.termName);
		}
		bool flag = true;
		if (1 < skill_data.user_player_num)
		{
			int num = 1;
			while (num < skill_data.user_player_num && flag)
			{
				Maid maid = GameMain.Instance.CharacterMgr.GetMaid(num);
				if (maid != null)
				{
					bool flag2 = !PersonalEventBlocker.IsEnabledYotodiSkill(maid.status.personal, skill_data.id);
					if (skill_data.recollectionHaremLockPersonalIds.Contains(maid.status.personal.id) || flag2)
					{
						flag = false;
					}
				}
				num++;
			}
		}
		UIWFTabButton component3 = UTY.GetChildObject(gameObject, "BG", false).GetComponent<UIWFTabButton>();
		component3.isEnabled = flag;
		if (onclick_event != null)
		{
			component3.onClick.Add(onclick_event);
		}
		return component3;
	}

	private UIWFTabButton CreateTypeAndCategoryButton(FreeSkillSelect.UpdateObject update_obj, string name, string nameTerm, bool enabled, EventDelegate onclick_event)
	{
		GameObject gameObject = update_obj.MoveButtonParent();
		if (gameObject == null)
		{
			gameObject = Utility.CreatePrefab(update_obj.button_parent, "SceneYotogi/SkillSelect/Prefab/CategoryBtn", true);
		}
		UILabel component = UTY.GetChildObject(gameObject, "Label", false).GetComponent<UILabel>();
		Localize component2 = component.GetComponent<Localize>();
		component.text = name;
		if (component2 != null && !string.IsNullOrEmpty(nameTerm))
		{
			component2.SetTerm(nameTerm);
		}
		UIWFTabButton component3 = UTY.GetChildObject(gameObject, "Button", false).GetComponent<UIWFTabButton>();
		gameObject.name = name;
		component3.isEnabled = enabled;
		if (enabled && onclick_event != null)
		{
			component3.onClick.Add(onclick_event);
		}
		return component3;
	}

	private void OnClickTypeBtnEvent(FreeSkillSelect.ButtonData type_btn_data)
	{
		this.update_obj_dic_["タイプ"].UpdateArrow(type_btn_data.tab_button_obj.gameObject);
		this.CreateCategory(type_btn_data);
	}

	private void OnClickCategoryBtnEvent(FreeSkillSelect.ButtonData categorybtn_data)
	{
		this.update_obj_dic_["カテゴリー"].UpdateArrow(categorybtn_data.tab_button_obj.gameObject);
		this.CreateSkill(categorybtn_data);
	}

	private void OnClickSkillBtnEvent(FreeSkillSelect.ButtonData skill_data)
	{
		this.update_obj_dic_["スキル"].UpdateArrow(skill_data.tab_button_obj.gameObject);
		this.select_skill_ = skill_data.skill_data;
		this.CreateStage(skill_data.skill_data);
		FreeSkillSelect.ButtonData buttonData = (skill_data.parent == null) ? null : ((skill_data.parent.parent == null) ? null : skill_data.parent.parent);
		string item = (buttonData == null) ? FreeSkillSelect.RootType.Null.ToString() : buttonData.root_type;
		HashSet<string> hashSet = new HashSet<string>();
		foreach (FreeSkillSelect.RootType rootType in new FreeSkillSelect.RootType[]
		{
			FreeSkillSelect.RootType.Null,
			FreeSkillSelect.RootType.Drunk,
			FreeSkillSelect.RootType.Mask,
			FreeSkillSelect.RootType.Drug,
			FreeSkillSelect.RootType.Faint,
			FreeSkillSelect.RootType.Confess
		})
		{
			hashSet.Add(rootType.ToString());
		}
		if (!hashSet.Contains(item))
		{
			List<Transform> childList = this.update_obj_dic_["レベル"].ui_grid.GetChildList();
			bool flag = true;
			for (int j = childList.Count - 1; j >= 0; j--)
			{
				UIWFTabButton componentInChildren = childList[j].gameObject.GetComponentInChildren<UIWFTabButton>();
				if (!(componentInChildren == null) && componentInChildren.isEnabled)
				{
					if (flag)
					{
						this.update_obj_dic_["レベル"].tab_panel.Select(componentInChildren);
					}
					else
					{
						componentInChildren.isEnabled = false;
					}
					flag = false;
				}
			}
		}
		else
		{
			List<Transform> childList2 = this.update_obj_dic_["レベル"].ui_grid.GetChildList();
			for (int k = 0; k < childList2.Count; k++)
			{
				UIWFTabButton componentInChildren2 = childList2[k].gameObject.GetComponentInChildren<UIWFTabButton>();
				if (!(componentInChildren2 == null))
				{
					componentInChildren2.isEnabled = true;
				}
			}
		}
	}

	private void OnClickLevelBtnEvent()
	{
		this.update_obj_dic_["レベル"].UpdateArrow(UIButton.current.gameObject);
		this.yotogi_mgr_.fix_skill_level = int.Parse(UIButton.current.gameObject.name);
	}

	private void OnClickStageEvent(YotogiStageUnit stage_unit)
	{
		this.select_stage_ = (this.user_request_stage = stage_unit.stage_data);
		this.is_day_time_ = stage_unit.is_daytime;
		this.FixSkill();
	}

	private static List<FreeSkillSelect.ButtonData> CreateButtonData(Maid maid, HashSet<int> selectableStageIds)
	{
		List<FreeSkillSelect.ButtonData> top_btn_data_list = new List<FreeSkillSelect.ButtonData>();
		Dictionary<string, KeyValuePair<FreeSkillSelect.ButtonData, Dictionary<string, FreeSkillSelect.ButtonData>>> type_data_dic = new Dictionary<string, KeyValuePair<FreeSkillSelect.ButtonData, Dictionary<string, FreeSkillSelect.ButtonData>>>();
		List<KeyValuePair<string, string>> baseCategoryDefine = new List<KeyValuePair<string, string>>();
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.Null.ToString(), "通常"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.Drunk.ToString(), "酔い"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.Mask.ToString(), "目隠し"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.Drug.ToString(), "媚薬"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.Confess.ToString(), "告白"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.Faint.ToString(), "気絶"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP01Harem.ToString(), "GP-01ハーレム"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP01Swapping.ToString(), "GP-01スワッピング"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP01NTR.ToString(), "GP-01寝取らせ"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP01NTRReport.ToString(), "GP-01寝取らせ報告"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP02Harem.ToString(), "GP-02ハーレム"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP02Swapping.ToString(), "GP-02スワッピング"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP02NTR.ToString(), "GP-02寝取らせ"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP02NTRReport.ToString(), "GP-02寝取らせ報告"));
		baseCategoryDefine.Add(new KeyValuePair<string, string>(FreeSkillSelect.RootType.GP02Yuri.ToString(), "GP-02百合"));
		Func<string, KeyValuePair<FreeSkillSelect.ButtonData, Dictionary<string, FreeSkillSelect.ButtonData>>> func = delegate(string typeName)
		{
			KeyValuePair<FreeSkillSelect.ButtonData, Dictionary<string, FreeSkillSelect.ButtonData>> result;
			if (type_data_dic.TryGetValue(typeName, out result))
			{
				return result;
			}
			FreeSkillSelect.ButtonData buttonData4 = new FreeSkillSelect.ButtonData();
			buttonData4.children_list = new List<FreeSkillSelect.ButtonData>();
			foreach (KeyValuePair<string, string> keyValuePair3 in baseCategoryDefine)
			{
				if (!(keyValuePair3.Key != typeName))
				{
					buttonData4.name = keyValuePair3.Value;
					break;
				}
			}
			if (string.IsNullOrEmpty(buttonData4.name))
			{
				buttonData4.name = typeName;
			}
			buttonData4.nameTerm = "SceneYotogi/スキル所属/" + buttonData4.name;
			buttonData4.root_type = typeName;
			top_btn_data_list.Add(buttonData4);
			type_data_dic.Add(buttonData4.root_type, new KeyValuePair<FreeSkillSelect.ButtonData, Dictionary<string, FreeSkillSelect.ButtonData>>(buttonData4, new Dictionary<string, FreeSkillSelect.ButtonData>()));
			FreeSkillSelect.ButtonData buttonData5 = top_btn_data_list[top_btn_data_list.Count - 1];
			for (int l = 0; l < 8; l++)
			{
				FreeSkillSelect.ButtonData buttonData6 = new FreeSkillSelect.ButtonData();
				buttonData6.children_list = new List<FreeSkillSelect.ButtonData>();
				FreeSkillSelect.ButtonData buttonData7 = buttonData6;
				Yotogi.Category category2 = (Yotogi.Category)l;
				buttonData7.name = category2.ToString();
				buttonData6.nameTerm = "SceneYotogi/スキルカテゴリー/" + buttonData6.name;
				buttonData6.parent = buttonData5;
				buttonData5.children_list.Add(buttonData6);
				type_data_dic[buttonData5.root_type].Value.Add(buttonData6.name, buttonData6);
			}
			return type_data_dic[buttonData4.root_type];
		};
		for (int i = 0; i < baseCategoryDefine.Count; i++)
		{
			func(baseCategoryDefine[i].Key);
		}
		CharacterMgr characterMgr = GameMain.Instance.CharacterMgr;
		int[] keyArray = maid.status.yotogiSkill.datas.GetKeyArray();
		Dictionary<int, List<Skill.Data>> dictionary = new Dictionary<int, List<Skill.Data>>();
		for (int j = 0; j < keyArray.Length; j++)
		{
			Skill.Data data = Skill.Get(keyArray[j]);
			if (data.specialConditionType != Skill.Data.SpecialConditionType.NewType)
			{
				if (PersonalEventBlocker.IsEnabledYotodiSkill(maid.status.personal, data.id))
				{
					if (data.IsExecPersonal(maid.status.personal))
					{
						bool flag = false;
						foreach (int item in data.playable_stageid_list)
						{
							flag = selectableStageIds.Contains(item);
							if (flag)
							{
								break;
							}
						}
						if (flag)
						{
							int category = (int)data.category;
							if (!dictionary.ContainsKey(category))
							{
								dictionary.Add(category, new List<Skill.Data>());
							}
							dictionary[category].Add(data);
						}
					}
				}
			}
		}
		foreach (KeyValuePair<int, List<Skill.Data>> keyValuePair in dictionary)
		{
			List<Skill.Data> value = keyValuePair.Value;
			value.Sort((Skill.Data a, Skill.Data b) => a.sortId - b.sortId);
		}
		List<Skill.Data> list = new List<Skill.Data>();
		foreach (KeyValuePair<int, List<Skill.Data>> keyValuePair2 in dictionary)
		{
			List<Skill.Data> value2 = keyValuePair2.Value;
			foreach (Skill.Data item2 in value2)
			{
				list.Add(item2);
			}
		}
		foreach (Skill.Data data2 in list)
		{
			int user_player_num = data2.user_player_num;
			if (1 < user_player_num)
			{
				int num = 0;
				for (int k = 0; k < characterMgr.GetMaidCount(); k++)
				{
					if (!(characterMgr.GetMaid(k) != null))
					{
						break;
					}
					num++;
				}
				if (num < user_player_num)
				{
					continue;
				}
			}
			if (data2.IsExecMaid(maid.status))
			{
				string arg = FreeSkillSelect.RootType.Null.ToString();
				if (Skill.Data.SpecialConditionType.Null <= data2.specialConditionType && data2.specialConditionType <= Skill.Data.SpecialConditionType.Confess)
				{
					arg = ((FreeSkillSelect.RootType)data2.specialConditionType).ToString();
				}
				else if (data2.specialConditionType == Skill.Data.SpecialConditionType.GP01Recollect)
				{
					FreeSkillSelect.RootType rootType;
					if (data2.category == Yotogi.Category.ハ\u30FCレム)
					{
						rootType = FreeSkillSelect.RootType.GP01Harem;
					}
					else
					{
						rootType = FreeSkillSelect.RootType.GP01Swapping;
						if (data2.name.Contains("報告"))
						{
							rootType = FreeSkillSelect.RootType.GP01NTRReport;
						}
						else if (data2.name.Contains("寝取り"))
						{
							rootType = FreeSkillSelect.RootType.GP01NTR;
						}
					}
					arg = rootType.ToString();
				}
				else if (data2.specialConditionType == Skill.Data.SpecialConditionType.GP02Recollect)
				{
					FreeSkillSelect.RootType rootType2;
					if (data2.category == Yotogi.Category.ハ\u30FCレム)
					{
						if (data2.name.Contains("百合"))
						{
							rootType2 = FreeSkillSelect.RootType.GP02Yuri;
						}
						else
						{
							rootType2 = FreeSkillSelect.RootType.GP02Harem;
						}
					}
					else
					{
						rootType2 = FreeSkillSelect.RootType.GP02Swapping;
						if (data2.name.Contains("報告"))
						{
							rootType2 = FreeSkillSelect.RootType.GP02NTRReport;
						}
						else if (data2.name.Contains("寝取り"))
						{
							rootType2 = FreeSkillSelect.RootType.GP02NTR;
						}
					}
					arg = rootType2.ToString();
				}
				else
				{
					if (data2.specialConditionType != Skill.Data.SpecialConditionType.OnlyRecollect)
					{
						continue;
					}
					arg = (string.IsNullOrEmpty(data2.customRecollectionCategoryName) ? "-" : data2.customRecollectionCategoryName);
				}
				FreeSkillSelect.ButtonData buttonData = func(arg).Value[data2.category.ToString()];
				if (buttonData != null)
				{
					FreeSkillSelect.ButtonData buttonData2 = new FreeSkillSelect.ButtonData();
					buttonData2.parent = buttonData;
					buttonData2.name = data2.name;
					buttonData2.skill_data = data2;
					buttonData.children_list.Add(buttonData2);
				}
			}
		}
		Action<string> action = delegate(string type)
		{
			Dictionary<string, FreeSkillSelect.ButtonData> value3 = type_data_dic[type].Value;
			HashSet<string> hashSet = new HashSet<string>();
			List<FreeSkillSelect.ButtonData> list2 = new List<FreeSkillSelect.ButtonData>();
			foreach (KeyValuePair<string, FreeSkillSelect.ButtonData> keyValuePair3 in value3)
			{
				if (keyValuePair3.Value.children_list != null && 1 <= keyValuePair3.Value.children_list.Count && !hashSet.Contains(keyValuePair3.Key))
				{
					hashSet.Add(keyValuePair3.Key);
					list2.Add(keyValuePair3.Value);
				}
			}
			type_data_dic[type].Key.children_list = list2;
		};
		foreach (FreeSkillSelect.ButtonData buttonData3 in top_btn_data_list)
		{
			if (buttonData3.root_type != FreeSkillSelect.RootType.Null.ToString())
			{
				action(buttonData3.root_type);
			}
		}
		return top_btn_data_list;
	}

	private static FreeSkillSelect.ButtonData GetButtonData(List<FreeSkillSelect.ButtonData> check_list, string name)
	{
		FreeSkillSelect.ButtonData result = null;
		if (check_list == null || string.IsNullOrEmpty(name))
		{
			return result;
		}
		for (int i = 0; i < check_list.Count; i++)
		{
			if (check_list[i] != null)
			{
				if (!string.IsNullOrEmpty(check_list[i].name) && check_list[i].name == name)
				{
					result = check_list[i];
					break;
				}
			}
		}
		return result;
	}

	public YotogiStage.Data select_stage
	{
		get
		{
			return this.select_stage_;
		}
	}

	public Skill.Data select_skill
	{
		get
		{
			return this.select_skill_;
		}
	}

	private Maid maid_;

	private List<FreeSkillSelect.ButtonData> button_data_list_;

	private Dictionary<string, FreeSkillSelect.UpdateObject> update_obj_dic_;

	private YotogiManager yotogi_mgr_;

	private Skill.Data select_skill_;

	private YotogiStage.Data select_stage_;

	private bool is_day_time_ = true;

	private YotogiStage.Data user_request_stage;

	private enum RootType
	{
		Null,
		Drunk,
		Mask,
		Drug,
		Faint,
		Confess,
		GP01Harem,
		GP01Swapping,
		GP01NTR,
		GP01NTRReport,
		GP02Harem,
		GP02Swapping,
		GP02NTR,
		GP02NTRReport,
		GP02Yuri
	}

	private class ButtonData
	{
		public UIWFTabButton tab_button_obj;

		public FreeSkillSelect.ButtonData parent;

		public List<FreeSkillSelect.ButtonData> children_list;

		public string name;

		public string nameTerm;

		public Skill.Data skill_data;

		public string root_type;
	}

	private class UpdateObject
	{
		public void Update()
		{
			this.ui_grid.Reposition();
			this.tab_panel.UpdateChildren();
			this.scroll_view.ResetPosition();
			this.ui_panel.UpdateAnchors();
		}

		public void MoveStorageRoom(bool click_event_clear)
		{
			if (this.storage_obj == null)
			{
				return;
			}
			Transform transform = this.button_parent.transform;
			Transform transform2 = this.storage_obj.transform;
			while (0 < transform.childCount)
			{
				GameObject gameObject = transform.GetChild(0).gameObject;
				UIWFTabButton componentInChildren = gameObject.GetComponentInChildren<UIWFTabButton>();
				if (componentInChildren != null)
				{
					componentInChildren.SetSelect(false);
					if (click_event_clear)
					{
						componentInChildren.onClick.Clear();
					}
				}
				gameObject.transform.SetParent(transform2, false);
				gameObject.transform.localPosition = Vector3.zero;
			}
			transform.DetachChildren();
		}

		public GameObject MoveButtonParent()
		{
			if (this.storage_obj == null)
			{
				return null;
			}
			GameObject gameObject = null;
			Transform transform = this.button_parent.transform;
			Transform transform2 = this.storage_obj.transform;
			if (0 < transform2.childCount)
			{
				gameObject = transform2.GetChild(0).gameObject;
				gameObject.transform.SetParent(transform, false);
			}
			return gameObject;
		}

		public GameObject MoveButtonParent(string object_name)
		{
			if (this.storage_obj == null || string.IsNullOrEmpty(object_name))
			{
				return null;
			}
			GameObject gameObject = null;
			Transform transform = this.button_parent.transform;
			Transform transform2 = this.storage_obj.transform;
			for (int i = 0; i < transform2.childCount; i++)
			{
				if (transform2.GetChild(i).name == object_name)
				{
					gameObject = transform2.GetChild(i).gameObject;
					gameObject.transform.SetParent(transform, false);
					break;
				}
			}
			return gameObject;
		}

		public void UpdateArrow(GameObject target_obj)
		{
			if (this.arrow_obj == null || target_obj == null)
			{
				return;
			}
			Vector3 position = target_obj.transform.TransformPoint(new Vector3(0f, 0f, 0f));
			Vector3 local_pos = this.arrow_obj.transform.parent.InverseTransformPoint(position);
			local_pos.x = this.arrow_obj.transform.localPosition.x;
			local_pos.y += 18f;
			Hashtable args = TweenHash.EaseOutQuint(TweenHash.Type.Position, local_pos, 0.3f);
			iTween.MoveTo(this.arrow_obj, args);
		}

		public void Clear()
		{
			Transform transform = this.button_parent.transform;
			for (int i = 0; i < transform.childCount; i++)
			{
				UnityEngine.Object.Destroy(transform.GetChild(i).gameObject);
			}
			transform.DetachChildren();
		}

		public GameObject button_parent;

		public UIGrid ui_grid;

		public UIWFTabPanel tab_panel;

		public UIScrollView scroll_view;

		public UIPanel ui_panel;

		public GameObject arrow_obj;

		public GameObject storage_obj;
	}
}
