﻿using System;

namespace PrivateMaidMode
{
	public class GP003MainMenuManager : WfScreenChildren
	{
		private CharacterMgr charaMgr
		{
			get
			{
				return GameMain.Instance.CharacterMgr;
			}
		}

		public override void Awake()
		{
			base.Awake();
		}

		protected override void OnCall()
		{
			GameMain.Instance.MainLight.Reset();
			GameMain.Instance.MainCamera.Reset(CameraMain.CameraType.Target, true);
			GameMain.Instance.SoundMgr.VoiceStopAll();
			for (int i = 0; i < this.charaMgr.GetMaidCount(); i++)
			{
				Maid maid = this.charaMgr.GetMaid(i);
				if (!(maid == null))
				{
					maid.Visible = true;
					maid.AllProcPropSeqStart();
				}
			}
		}

		protected override bool IsCallFadeIn()
		{
			return !this.charaMgr.IsBusy();
		}

		protected override void OnFinish()
		{
			if (this.screenManager.MoveScreen.IsExistNextFile())
			{
				this.screenManager.CallScreen("Move");
			}
		}

		[NonSerialized]
		public SceneGP003MainMenuScreenManager screenManager;
	}
}
